////////////////////////////////////////////////////////////////////// 
// extras/pedstats.h 
// (c) 2000-2003 Goncalo Abecasis
// 
// This file is distributed as part of the MERLIN source code package   
// and may not be redistributed in any form, without prior written    
// permission from the author. Permission is granted for you to       
// modify this file for your own personal use, but modified versions  
// must retain this copyright notice and must not be distributed.     
// 
// Permission is granted for you to use this file to compile MERLIN.    
// 
// All computer programs have bugs. Use this file at your own risk.   
// 
// Wednesday June 11, 2003
// 
 
#ifndef __PEDSTATS_H__
#define __PEDSTATS_H__

#include "Constant.h"
#include "MathStats.h"
#include "MathMatrix.h"
#include "MathVector.h"
#include "MathConstant.h"
#include "Parameters.h"
#include "Pedigree.h"
#include "Error.h"
#include "IBD.h"

#include <stdio.h>

void ReadParameters(int argc, char * argv[]);
void FamilyStatistics();
void RelativePairs(bool (*filter)(Person &, Person &) = NULL);
void TraitStatistics();
void CovarStatistics();
void AffectionStatistics();
void MarkerStatistics();
void HWStatistics(bool foundersOnly = false);

bool FilterOnCovariate(Person &p1, Person & p2);
bool FilterOnTrait(Person & p1, Person & p2);
int  Generation(Person * p);
void MakeIndex(IntArray & index, IntArray & counts);

bool isParent(Person * a, Person * b);
bool isOrderedParent(Person *a, Person *b);
bool isGrandParentOffspring(Person * a, Person * b);
bool isOrderedGrandParentOffspring(Person *a, Person *b);
bool isAvuncular(Person * a, Person * b);
bool isOrderedAvuncular(Person *a, Person *b);

bool isCousin(Person *a, Person *b);
bool isSib(Person *a, Person *b);
bool isHalfSib(Person *a, Person *b);




#endif


 
 
