////////////////////////////////////////////////////////////////////// 
// extras/pedstats_pdf.h 
// (c) 2000-2003 Goncalo Abecasis
// 
// This file is distributed as part of the MERLIN source code package   
// and may not be redistributed in any form, without prior written    
// permission from the author. Permission is granted for you to       
// modify this file for your own personal use, but modified versions  
// must retain this copyright notice and must not be distributed.     
// 
// Permission is granted for you to use this file to compile MERLIN.    
// 
// All computer programs have bugs. Use this file at your own risk.   
// 
// Wednesday June 11, 2003
// 
 

// Written by Jan Wigginton

#ifndef __PEDSTATS_PDF_H__
#define __PEDSTATS_PDF_H__

#include "PDFhistogram.h"
#include "PDFlinechart.h"

void GraphAffectionStatistics(PDF &pdf);
void GraphAffection(PDF & pdf, int index);

void GraphFamilyStatistics(PDF & pdf);

void GraphMarkerStatistics(PDF & pdf);
void GraphMarker(PDF & pdf, int m);

void GraphCovariateStatistics(PDF & pdf);
void GraphCovariate(PDF & pdf, int index);

void GraphTraitStatistics(PDF & pdf);
void GraphTrait(PDF & pdf, int index);

void GraphPairVars(PDF & pdf, bool is_covariate);
void GraphPairAffections(PDF & pdf);

// Auxilliary graphing functions
//

#define  FILTER_FUNC    bool (*filter)(Person &, Person &)
#define  RELATIONSHIP_FILTER bool (*relationship_filter) (Person *, Person *)

void   GraphPairAffection(PDF & pdf, PDFHistogram & chart,
  bool (*relationship_filter)(Person *, Person *), const char * tag, int index);
int    GetPairAffectionData(Vector & d_sibs, Vector & ca_sibs, Vector & cu_sibs,
  bool (*relationship_filter)(Person *, Person *),int index);

void GraphVarByPairs(PDF & pdf, bool is_covariate, const char * x_tag, const char * y_tag,
  bool (*relationship_filter)(Person *, Person *), bool is_ordered, const char *alt_title = "");
double GetPairData(FILTER_FUNC, RELATIONSHIP_FILTER, PDFLineChart & chart,
  int & sib_pairs, bool is_covariate = false, bool is_ordered = true);

void   GraphVarOverall(PDF & pdf, PDFHistogram & chart, Vector & values);
void   GraphVarBySex(PDF & pdf, PDFHistogram & chart, Vector & v_female,
  Vector & v_male, bool do_subtitle );
void   GraphVarByFounder(PDF & pdf, PDFHistogram & chart, Vector & v_founder,
  Vector & v_nonfounder, bool do_subtitle);

void MakePageHeader(PDF & pdf, const char *title, const char * sub_title);
void DrawInArea(PDF & pdf, PDFChartBasics * chart, int row_to_use, int col_to_use, int rows, int cols);
void DrawArea(PDF & pdf, PDFChartBasics * chart, int call);


#endif

 
 
