////////////////////////////////////////////////////////////////////// 
// merlin/NPL-ASP.h 
// (c) 2000-2003 Goncalo Abecasis
// 
// This file is distributed as part of the MERLIN source code package   
// and may not be redistributed in any form, without prior written    
// permission from the author. Permission is granted for you to       
// modify this file for your own personal use, but modified versions  
// must retain this copyright notice and must not be distributed.     
// 
// Permission is granted for you to use this file to compile MERLIN.    
// 
// All computer programs have bugs. Use this file at your own risk.   
// 
// Wednesday June 11, 2003
// 
 
#ifndef __NPL_ASP_H__
#define __NPL_ASP_H__

#include "Pedigree.h"
#include "Mantra.h"
#include "Tree.h"

class NPL_ASP_Tree : public Tree
   {
   public:
      void   ScoreNPL(Mantra & f, int affection);

   private:
      int    RecursivelyScoreNPL(Mantra & m, int bit);
      bool   isRedundantNPL(Mantra & m, int pivot);
      virtual double CalculateNPL(Mantra & m) = 0;
      virtual void   PrepareForScoring(Mantra & m);

   };

class NPL_ALL : public NPL_ASP_Tree
   {
   protected:
      virtual double CalculateNPL(Mantra & m);
      virtual void   PrepareForScoring(Mantra & m);

      static const double factors[20];
      static const double reciprocals[20];

      IntArray counts;
      int      permutations;
      double   permutationWeigth;
   };

class NPL_Pairs : public NPL_ASP_Tree
   {
   protected:
      virtual double CalculateNPL(Mantra & m);
   };

#endif 
 
